/* ****************************************************************************
 *    File Name : 27HC1616.D 
 *    Last Modify Date : 91. 3. 7 
 *
 *    Pin num : 40-pin   (A0..A13     D0..D15) 
 *    Size    : 3FFF
 *-----------------------------------------------------------------------------
 *    Vpp=13.0(12.5)	Vcc=6.5(6.0)	Dur=100us(1ms) (Express Algo.:FastAlgo)
 *----------------------------------------------------------------------------- 
 *    Device  : MICROCHIP	27HC1616
 * ************************************************************************** */
declaration
   dataunit : byte;
   functions
      Program
      Read
      Verify
      Blank_Check
      Data_Compare
      Auto
   ;
   Manufacturers
      MICROCHIP
   ;
   Devices
      D27HC1616
   ;
   chips = Vpp,   CE,  D15,D14, D13, D12, D11, D10, D9, D8, 
   	   GND1_, D7 , D6, D5 , D4 , D3 , D2 , D1 , D0, OE,
	   A0, 	  A1 , A2, A3 , A4 , A5 , A6 , A7 , A8, GND2_,
	   A9,    A10, A11,A12, A13, NC1, NC2, NC3, PGM,Vcc;
   $v2 = Vpp;
   $v3 = Vcc;
endd

/* -----------------------------------------------------------------------
 * Failf () ---> Fail address setting
 * ----------------------------------------------------------------------- */
int Failf (hwhb, hwlb, lwhb, lwlb ,tmp)
int hwhb, hwlb, lwhb, lwlb, tmp;
{
int high, low;

   high = (hwhb << 8) | hwlb;
   low  = (lwhb << 8) | lwlb;

   @Fail high, low, tmp;
}
/* -----------------------------------------------------------------------
 * init () ---> Initial processing
 * ----------------------------------------------------------------------- */
int     init (vol2, vol3)
voltage vol2, vol3;
{
   @Vout 1	, vol2;
   @Vout 2	, vol2;            /* Voltage Source #2 */
   @Vout 3	, vol3;            /* Voltage Source #3 */
   @Out GND1_   , @G;     /* Ground output */
   @Out GND2_	, @G;
   @Delay 10	, @ms;

   @Out A [0..13] , @W;
   @Out D [0..15 ], @Z; 

   @Out CE        , @W;       
   @Out OE        , @W;       
   @Out PGM	  , @W;
   @Out Vcc	  , @W;
   @Out Vpp	  , @W;

   @Out CE       , @H;       /* Chip enable  is High */
   @Out OE       , @H;       /* Out  enable  is High */
   @Out PGM	 , @H;
   @Out Vcc	 , @H;
   @Out Vpp	 , @H;

   @Out Vcc	 , @O;       /* Vcc Enable */
   @Out Vpp	 , @O;       /* Vpp Enable */
   @Delay 100	 , @us;
}
/* -----------------------------------------------------------------------
 * InitProcess () ---> Initial Buffer | Voltage source
 * ----------------------------------------------------------------------- */
int InitProcess ()
{
   if (FUNCTION != Program) 	init ( 5.0 , 5.0 );
   else  			init (13.0 , 6.5 );
}
/* -----------------------------------------------------------------------
 * read () ---> read processing
 * ----------------------------------------------------------------------- */
int read (row)
int	row;
{
int  hwhb, hwlb, lwhb, lwlb;
int  sll, ell, slh, elh, shl, ehl;
int  tmp, tmp1, tmp2, incval;

   @Set B_HADDR, B_LADDR;
   @Inc	__B_START__;

   if (SPLIT == 1) incval = 1;
   else            
   {
      incval = SPLIT + 1;
      @Inc __B_START__;
   }
   
   hwhb = hwlb = lwlb = lwhb = 0;
   sll = ell = slh = elh = shl = ehl = 0;
   tmp = tmp1 = tmp2 = 0;

   if (FUNCTION == Read ) 
   {
      @Display 26, row, "Reading...";
      @CheckSumON;
   }
   else if (FUNCTION == Verify)		@Display 26, row, "Verifying...";
   else if (FUNCTION == Blank_Check)	@Display 26, row, "Blank Checking...";
   else 			        @Display 26, row, "Data Comparing...";   
   
   for ( hwhb=0 /* S_HWHB */ ; hwhb<=0 /* E_HWHB */; hwhb++ )
   {
      @Display 64, 9, hwhb;
      
      for ( hwlb=S_HWLB; hwlb<=E_HWLB; hwlb++ )
      {
	 @Display 66, 9, hwlb;
	 
	 if (hwlb == S_HWLB) slh = S_LWHB;
         else                slh = 0;
         if (hwlb == E_HWLB) elh = E_LWHB;
         else                elh = 0xFF;

	 for ( lwhb=slh; lwhb<=elh; lwhb++)
         {
	    @Display 68, 9, lwhb;
	    @Out A [8..13], lwhb;   /* Output High word address */
	    
	    if (lwhb == S_LWHB) sll = S_LWLB;
            else                sll = 0;
            if (lwhb == E_LWHB) ell = E_LWLB;
            else                ell = 0xFF;
            
	    for ( lwlb=sll ; lwlb<=ell; lwlb++)
	    {
	       @Out A [0..7], lwlb;    /* Low  byte address output */
	       
	       @Out CE       , @L;
	       @Out OE       , @L;
	       @In  D [0..15], tmp;
	       @Out CE       , @H;	       
	       @Out OE       , @H;

	       if (FUNCTION == Read)         
	       {
	          @Load tmp;	/*  Load	Low-byte  */
	          @Inc 1;
	          tmp >>= 8;	/*  Load	High-Byte   */
	          @Load tmp;
	       }
	       else if (FUNCTION == Blank_Check)   /* Blank_Char */
	       {
		    if (tmp != 0xFFFF)	Failf(hwhb, hwlb, lwhb, lwlb, tmp);
	       }
	       else if (FUNCTION == Verify)
	       {
		   @Store tmp1;		/*  Low Byte */
		   @Inc	1;
		   @Store tmp2;		/*  High Byte */
		   tmp1 |= tmp2<<8;
		   if (tmp != tmp1)  Failf (hwhb, hwlb, lwhb, lwlb, tmp);
	       }
	       else if (FUNCTION == Data_Compare) 	   
	       {
	       	    @Store      tmp1;
		    @Inc        1;	
	       	    @Store	tmp2;
	       	    tmp1 |= tmp2<<8;
	       	    @Compare	tmp, tmp1;
	       }	       
	       if (FUNCTION != Blank_Check)	@Inc incval;
            }
	 }
      }
   }
   if 	   (FUNCTION == Read)		@Display 26, row, "Read OK!   ";
   else if (FUNCTION == Verify)		@Display 26, row, "Verification OK!";
   else if (FUNCTION == Blank_Check)	@Display 26, row, "Blank Check OK!  ";
   else 			        @Display 26, row, "Data Comparison OK!";   
}
/* -----------------------------------------------------------------------
 * program() ---> Control main
 * ----------------------------------------------------------------------- */
int	program (row, kind)
int	row, kind;
{
int  hwhb, hwlb, lwhb, lwlb;
int  sll, ell, slh, elh, shl, ehl;
int  tmp , tmp1, tmp2, failcnt, incval;

   @Set  B_HADDR, B_LADDR;
   @Inc  __B_START__;
   
   if (SPLIT == 1) incval = 1;
   else            
   {
      incval = SPLIT + 1;
      @Inc __B_START__;
   }
   
   failcnt = tmp = tmp1 = tmp2 = 0;
   lwlb = lwhb = hwhb = hwlb = 0;
   sll = ell = slh = elh = shl = ehl = 0;
   
   @Display 26, row, "Programming...";      

   for ( hwhb=0 ; hwhb<=0; hwhb++ )
   {
       @Display 64, 9, hwhb;

       for ( hwlb=S_HWLB; hwlb<=E_HWLB; hwlb++ )
       {
	   @Display 66, 9, hwlb;
	   if (hwlb == S_HWLB) slh = S_LWHB;
           else                slh = 0;
           if (hwlb == E_HWLB) elh = E_LWHB;
           else                elh = 0xFF;

	   for ( lwhb=slh; lwhb<=elh; lwhb++)
	   {
	       @Display 68, 9, lwhb;
	       @Out A [8..13], lwhb;   /* Output High word address */
	       
	       if (lwhb == S_LWHB) sll = S_LWLB;
               else                sll = 0;
               if (lwhb == E_LWHB) ell = E_LWLB;
               else                ell = 0xFF;

	       for ( lwlb=sll; lwlb<=ell; lwlb++)
	       {
		  @Store tmp;	/* Low Byte  */
		  @Inc	1;
		  @store tmp1;	/* High Byte */
		  tmp |= tmp1<<8;
		  
		  if (tmp == 0xFFFF)
		  {
		      @Inc incval;
		      continue;
		  }
		  
		  @Out D [0..15], @W;		  
	          @Out A [0..7] , lwlb;
		  @Out D [0..15], tmp;
		  @Out CE	, @L;
		  
		  @Out    PGM	, @L;				  
		  @Delay  100	, @us;
		  @Out    PGM	, @H;
		  
		  /* -------- One word Verify ----------- */
		  @Out D [0..15] , @Z;
		  @Out OE	 , @L;
		  @In  D [0..15] , tmp2;
		  
		  @Out OE        , @H;
		  @Delay 100	 , @us;
		  
		  if (tmp != tmp2)
                  {
		     if (failcnt > 10 ) Failf (hwhb, hwlb, lwhb, lwlb, tmp2);
		     else
		     {
			++ failcnt;
			lwlb--;
			@Dec	1;
		     }
                  }
		  else
		  {
			failcnt = 0;
			@Inc incval;
		  }
               }
	   }
       }
   }
   @Display 26, row, "Program OK!   ";
   if (kind == 0)	row = 7;
   else			row = 8;
   FUNCTION = Verify;
   @Vout 2,	5.0;
   @Vout 3, 	5.0;
   
   read (row);		/*  Verify  */
}
/* -----------------------------------------------------------------------
 * main () ---> Control main
 * ----------------------------------------------------------------------- */
int main ()
{
   InitProcess();

   if ( FUNCTION == Auto )
   {
	FUNCTION = Blank_Check;
	read (6);

	FUNCTION = Program;
	InitProcess();	
	program(7, 1);
   }
   else if ( FUNCTION == Program ) program(6, 0);
   else 			   read (6);
}
/* ---------------------------- End of program --------------------------- */ 